/************************************************************************
 *	CarbonCopies							*
 *	errorlevel =	0 -   		*
 *			1 -						*
 *			2 -   			*
 *			3 -   				*
 *			4 -    ()		*
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <ctype.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/types.h>
#include <locale.h>
#include "carboncopies.h"

#define MAX	766		// name[255] + emailpath[255] + 1
#define MMAX	256		// MAX/2
#define	MAXEMAIL	75	//   e-mail .

#define	FROM	"From: "		// cc = 0
#define	TO0	"X-Comment-To: "	// cc = 1
#define	TO1	"To: "			// cc = 1
#define	SUBJ	"Subject: "		// cc = 2
					// cc = 3

#define XREF	"Xref: "


struct CONF {
	int num;		//  0:   'email-path'  e-mail.
	int cc;
	char name[MMAX+1];
	char emailnewsgroup[MMAX+1];
	int ii;			//  1: ""  
				// 	 .
} conf[MAXCC];

static int RMAXCC = 0;
static int num_msg = 0;

#ifndef	NSPOOL
static char *rfc_headers[] = { RFC_HEADERS, NULL };
#endif

int main()
{
	int c, i, num;
	char cctmp[MMAX];
	char tmp_msg[MMAX];
	char path[MMAX];
	char prog[MMAX];
	char buf[MMAX];
	FILE *f;

	debuglog("Run Program\n");

	//       - /path/cc.tmp.<PID>
	sprintf( cctmp, "%s.%d.%d", CCTMP, time( NULL ), getpid() );

	debuglog("  \"%s\"\n",cctmp);

	//          
	if( ( f = fopen( cctmp, "w" ) ) == NULL )
	{
	    errorlog("(main)     ");
	    exit( 2 );
	}
	while( ( c = getchar () ) != EOF )
		putc( c, f );
	fclose( f );

	debuglog("   \n");

	readconf();
	xcommentto( cctmp );
	for (i=0; i<RMAXCC; i++)
	{
	    if( conf[i].ii == 1 )
	    {
		debuglog("  - ,    ;)\n");

		if( conf[i].num == 0 )
		{
			debuglog("   -.\n");

			sendemail( cctmp, i );
			continue;
		}
#ifdef	NSPOOL
		//      - /spool/number
		num_msg = number ( conf[i].num );
		debuglog("num = %i\n", num_msg);

		//   '.'  '/'
		strcpy( buf, conf[i].emailnewsgroup ); c = 0;
		while( buf[c] != 0 ) if ( buf[c++] == '.' ) buf[c-1] = '/';
		sprintf( path, "%s/%s/%d", SPOOL, buf, num_msg );

		debuglog("    - %s\n", path);

		copymsg( i, cctmp, path );	//    spool
		
		sprintf(prog, "%s %s >/dev/null", PROG, conf[i].emailnewsgroup);
		system( prog );		//  
		debuglog("%s\n", prog);
#else
		_creat();		//  lock -

		//  ,    inews
		sprintf( tmp_msg, "%s.%d.%d", TEMP_MSG, time( NULL ), getpid() );

		copymsg( i, cctmp, tmp_msg ); 	//    TEMP_MSG

		sprintf(prog, "%s -n \"%s\" %s", INEWS_COMMAND, 
			    conf[i].emailnewsgroup, tmp_msg);
		system( prog );		//    
		debuglog("%s\n", prog);
		
		remove( tmp_msg );	// "". ;)
#endif		
		debuglog(" LOCK \n");
		remove( LOCK );	//  lock - (  !)		
	    }
	}
	//    .
	debuglog("  \n");
	remove( cctmp );	//   

	debuglog("Exit Program.\n");
	exit( 0 );
}

xcommentto(char *cctmp)
{
	int i = 0;
	char buf[MMAX+1];
	char tmp[MMAX+1];
	char next_cc;
	FILE *f;

	debuglog("xCommentTo\n");

	if( ( f = fopen( cctmp, "r" ) ) == NULL ) 
	{
	    errorlog("(xcommentto)    ");
	    exit( 2 );
	}
	while( i != RMAXCC )
	{
		debuglog("  %i ( %i)   %i\n", 
			i+1, RMAXCC, conf[i].cc);

		next_cc = 0;
		while( fgets( buf, MMAX, f ) != NULL )
		{
			if( strlen( buf ) == MMAX ) exit( 4 );
			switch( conf[i].cc )
			{
			case 0:
//				debuglog("<From>\n");
				if(strncmp(buf,FROM,strlen(FROM))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					log( i );
					conf[i].ii = 1;
					next_cc = 1;
					debuglog("s = %s\n", buf);
#ifdef	FMSG
					fclose( f );					  
					return( i );
#endif
				  }
				}
				break;
			case 1:
//				debuglog("<To>\n");
				if(strncmp(buf,TO0,strlen(TO0))==0||
			     	strncmp(buf,TO1,strlen(TO1))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					log( i );
					conf[i].ii = 1;
					next_cc = 1;
					debuglog("s = %s\n", buf);
#ifdef	FMSG
					fclose( f );					  
					return( i );
#endif
				  }
				}
				break;
			case 2:
//				debuglog("<Subj>\n");
				if(strncmp(buf,SUBJ,strlen(SUBJ))==0)
				{
				  if(strstr( buf, conf[i].name )!=0)
				  {
					log( i );
					conf[i].ii = 1;
					next_cc = 1;
					debuglog("s = %s\n", buf);
#ifdef	FMSG
					fclose( f );					  
					return( i );
#endif
				  }
				}
				break;
			case 3:
//				debuglog("<Text>\n");
				if(strstr( buf, conf[i].name )!=0)
				{
					log( i );
					conf[i].ii = 1;
					next_cc = 1;
					debuglog("s = %s\n", buf);
#ifdef	FMSG
					fclose( f );					  
					return( i );
#endif
				}
				break;
			case 4:
//				debuglog("<TeXt>\n");
				strlwr( buf );
				strcpy( tmp, conf[i].name );
				strlwr( tmp );
				if(strstr( buf, tmp )!=0)
				{
					log( i );
					conf[i].ii = 1;
					next_cc = 1;
					debuglog("s = %s\n", buf);
#ifdef	FMSG
					fclose( f );					  
					return( i );
#endif
				}
				break;
			}
			if (next_cc) break;			
		}
		i++;
		rewind( f );	//   
	}
	fclose( f );	//  
	return( -1 );
}

readconf()
{
	int max=0;
	char buffer[MAX];
	FILE *f;
	
	debuglog(" \n");

	if( ( f = fopen( CONFIG, "r" ) ) == NULL ) 
	{
	    errorlog("(readconf)   .");
	    exit( 2 );
	}
	while( fgets( buffer, MAX, f ) != NULL && max++ != MAXCC )
	{
		if( buffer[0] != '#' )
		{
			sscanf( buffer, "%u|%u|%[^|]|%[^|\n]",
			  &conf[RMAXCC].num, &conf[RMAXCC].cc,
			  &conf[RMAXCC].name, &conf[RMAXCC].emailnewsgroup );
			conf[RMAXCC].ii = 0;

			if ( conf[RMAXCC].name[0] == '\0' ||
			     conf[RMAXCC].emailnewsgroup[0] == '\0')
			{
			    debuglog("config null string skip\n");
			} 
			else
			{
			    debuglog("config str = %i, %i, %s, %s\n", 
				conf[RMAXCC].num, conf[RMAXCC].cc,
				conf[RMAXCC].name, conf[RMAXCC].emailnewsgroup);
			    RMAXCC++;
			}
		}
	}
	fclose( f );
}

#ifdef	NSPOOL
number(int n)
{
	int num = 1;
	char path[MMAX+1];
	FILE *f;

	debuglog("number for %i\n", n);

	_creat();	//  lock -
	sprintf( path, "%s.%d", NUM, n );	// /path/.cc.status.<num>
	if( ( f = fopen( path, "r" ) ) != NULL )
	{
		fscanf( f, "%u", &num );	//  
		if( num == 0 )	num = 1;
		fclose( f );
	}
	if( ( f = fopen( path, "w" ) ) == NULL ) exit( 2 );
	if( num < 1 ) num = 1;	// secure
	fprintf( f, "%d", num+1 ); //    .  
	fclose( f );

	debuglog("number = %i\n", num);
	
	return( num );		//    .
}
#endif

//  lock - (    ).
_creat()
{
	FILE *f;

	debuglog("creating lock-file... ( \"\")\n");

	//   lock -.   - .
	while( ( access( LOCK, F_OK ) ) == 0 ) sleep( 1 );

	debuglog("        LOCK\n");

	//  lock -.
	if( ( f = fopen ( LOCK, "w" ) ) == NULL ) 
	{
	    errorlog("(_creat)    LOCK ");
	    exit( 2 );
	}
	fprintf( f, "%d", getpid() );	//   lock - PID 
	fclose( f );

	debuglog("create lock-file [ok]\n");
}

//     e-mail
//     'Mail'
sendemail(char *cctmp, int num)
{
	char mail[MAX];
	
	debuglog(" --\n");

	//   e-mail .
	if( strlen( conf[num].emailnewsgroup ) > MAXEMAIL )
	{
		sprintf( mail, "Config Error in - %s", 
			conf[num].emailnewsgroup );
		errorlog( mail );	// secure
		exit( 3 );
	}
	sprintf( mail, "%s %s < %s", MAIL, conf[num].emailnewsgroup, cctmp );

	debuglog("mail = %s\n", mail);

	system( mail );	//  e-mail.
}

// .
log(int num)
{
	char buffer[MAX];
	FILE *f;

	logtime( buffer );
	sprintf( buffer, "%s Carbon Copy[%i]: string \"%s\" -> \"%s\"\n",
		buffer, conf[num].cc, conf[num].name,	conf[num].emailnewsgroup );
	if( ( f = fopen ( LOG, "a" ) ) == NULL )  exit( 2 );
	fputs( buffer, f );
	fclose( f );
}

//    debug.
debuglog(char *format, ...)
{
#ifdef	ALEC_DEBUG
	va_list args;
	char buffer[MAX];
	FILE *f;

	logtime( buffer );
	if( ( f = fopen ( DEBUG_LOG, "a" ) ) == NULL ) 
	{
	    errorlog("(debuglog)    debug ");
	    exit( 2 );
	}
	fprintf( f, "%s ", buffer);
	va_start(args, format);
	vfprintf (f, format, args);
	va_end(args);
	fclose( f );
#endif
}

errorlog(char *buf)
{
#ifdef	WERROR
	char buffer[MAX];
	FILE *f;

	logtime( buffer );
	sprintf( buffer, "%s %s", buffer, buf );
	if( ( f = fopen ( LOG, "a" ) ) == NULL )  exit( 2 );
	fputs( buffer, f );
	fclose( f );
#endif
//	exit( 3 );
}

//  .
logtime(char *buf)
{
	char buffer[MAX];
	time_t timv = time( 0 );
	struct tm *local_tm = localtime( &timv );

	strftime( buf, MAX, "%b %d %H:%M:%S", local_tm );
	sprintf( buf, "%s [%d]", buf, getpid() );
}

//     .
// (   !)
// TODO -    ! ;(
strlwr(char *c)
{
	setlocale(LC_CTYPE,"");
	while( *c )
	{
		*c = tolower( *c );
		++c;
	}
}
copymsg(int i, char *old_f, char *new_f)
{
#ifdef	NSPOOL
	char b[MAX], b1[MAX], b2[MAX], b3[MAX];
#else
	char b[MAX], b1[MAX];
#endif
	char NewsGroups[MAX];
	FILE *fi, *fo;
	char Header=1;
	char **hdr;
	int lhdr;
	
	debuglog("  %s  %s\n", old_f, new_f);

    	if( ( fo = fopen ( new_f, "w" ) ) != NULL )
	{
	    if( ( fi = fopen( old_f, "r" ) ) != NULL )
	    {
		debuglog("   /\n");
#ifdef	NSPOOL
		while( fgets( b, MAX, fi ) != NULL)
		{
		//  Xref:    .
		    if( strncmp(b,XREF,strlen(XREF))==0)
		    {
			sscanf( b, "%[^ ] %[^ ] %[^ \n]", &b1, &b2, &b3);
			sprintf( b, "%s %s %s:%i\n",
			    b1, b2, conf[i].emailnewsgroup, num_msg);
		    }
		    fputs( b, fo );
		}
#else
		while( fgets( b, MAX, fi ) != NULL)
		{
		    if ( strlen( b )==1 ) {
			if (Header) {
			    Header = 0;
			    debuglog(" .\n");
			    sprintf(b1, "%s\n %s", b, NewsGroups);
			    fputs( b1, fo );
			}
		    }
		    if ( Header ) {
			if(strncmp(b,NEWSPATH,strlen(NEWSPATH))==0)
			{
			    b[strlen(b)-1] = 0;
			    sprintf(b1, "%s!%s\n", b, NewsPathTail);
			    fputs( b1, fo );
			    debuglog("%s", b1);
			}
			if(strncmp(b,NEWSGROUPS,strlen(NEWSGROUPS))==0)
			{
			    strcpy( NewsGroups, b );
			    debuglog("%s", b);
			}
			else
			{
			    for( hdr=rfc_headers; *hdr; hdr++)
			    {
				lhdr = strlen( *hdr );
				if( strncmp(b, *hdr, lhdr)==0 ) {
				    fputs( b, fo );
				    debuglog("    - %s\n", *hdr);
				}
			    }
			}
		    }
		    else fputs( b, fo );
		}
		debuglog("  .\n");
#endif
		fclose( fi );
	    }
	    else
	    {
		errorlog("(copymsg)    ");
		debuglog("      \n");
	    }
	    fclose( fo );
	}
	else
	{
	    errorlog("(copymsg)    Carbon-");
	    debuglog("      \n");
	}
}
